기본 콘텐츠로 건너뛰기

백준알고리즘 7576번, 토마토 풀이

토마토의 상태가 행렬로 주어질 때, 모든 토마토가 익는데 걸리는 시간을 구하는 문제입니다. 
큐를 이용해서 BFS로 풀었습니다. 공부많이 됐네용.
입력값이 행렬로 주어져서 인접행렬로 풀었는데, 다음에는 인접 리스트로 푸는 문제를 도전해보겠습니다

--------------------------------------------------------------------------------

#include <stdio.h>
#include <string.h>
#include <queue>

using namespace std;

int g[1000][1000];
int M;
int N;

int BFS();

pair<int, int> temp;
queue < pair<int,int> > q;

int main(void) {
memset(g, 0, sizeof g);
bool check_allzero = true; // 입력값이 모두 0인경우 확인용
bool check_allone = true; // 입력값이 모두 1또는 -1인 경우 확인용
bool check_zero = false;
int n1, n2, min;

#ifndef ONLINE_JUDGE
freopen("input.txt", "r", stdin);
freopen("output.txt", "w", stdout);
#endif

scanf("%d %d\n", &n1,&n2);
N = n1; M = n2;
for (int i = 0; i < n2; i++) {
for (int j = 0; j < n1; j++) {
scanf("%d ", &g[i][j]);
if (g[i][j] == 1 || g[i][j] == -1)
check_allzero = false;
else
check_allone = false;
}
}

if (check_allone == true) {
printf("%d\n", 0);
return 0;
}

if (check_allzero == true) {
printf("%d\n", -1);
return 0;
}


for (int i = 0; i < n2; i++) {
for (int j = 0; j < n1; j++) {
if (g[i][j] == 1)
q.push(pair<int,int>(i,j));
}
}
printf("%d\n",BFS());

#ifndef ONLINE_JUDGE
fclose(stdin);
fclose(stdout);
#endif
return 0;
}

int BFS() {
pair<int, int> temp;
while (!q.empty()) {
temp = q.front();
q.pop();
if (temp.first > 0 && g[temp.first - 1][temp.second] == 0) { // 위쪽에 안익는 토마토가 있으면, 현재 값의 +1로 할당
//현재 값의 +1로 할당해주는 이유는 같은 값으로 할당해버리면 그 토마토를 접근했을때 그 토마토가 또 주변의 토마토를 익게 만들기 때문입니다.
g[temp.first - 1][temp.second] = g[temp.first][temp.second] + 1;
q.push(pair<int, int>(temp.first - 1, temp.second));
}

if (temp.first < M - 1 && g[temp.first + 1][temp.second] == 0) { // 아래쪽에 안익는 토마토가 있으면, 현재 값의 +1로 할당
g[temp.first + 1][temp.second] = g[temp.first][temp.second] + 1;
q.push(pair<int, int>(temp.first + 1, temp.second));
}

if (temp.second > 0 && g[temp.first][temp.second - 1] == 0) { // 왼쪽에 안익는 토마토가 있으면, 현재 값의 +1로 할당
g[temp.first][temp.second - 1] = g[temp.first][temp.second] + 1;
q.push(pair<int, int>(temp.first, temp.second-1));
}

if (temp.second < N - 1 && g[temp.first][temp.second + 1] == 0) { // 오른쪽에 안익는 토마토가 있으면, 현재 값의 +1로 할당
g[temp.first][temp.second + 1] = g[temp.first][temp.second] + 1;
q.push(pair<int, int>(temp.first, temp.second+1));
}
}
    
    for (int i = 0; i < M; i++) {
for (int j = 0; j < N; j++) {
if (g[i][j] == 0)
return -1;
}
}
    
return g[temp.first][temp.second]-1;
}

댓글

이 블로그의 인기 게시물

좌표압축

알 고리즘을 풀다 보면 좌표압축이라는 테크닉이 필요합니다. 저는 좌표압축을  "순위가 중요한 알고리즘에서, 입력값의 갯수보다 입력값의 범위가 클 때 사용하는 방법",  이라고 생각하고 있습니다. 1차원의 좌표로 예를 들어보겠습니다. n개의 x값 을 입력 받아, 입력 중 두개의  x1,x2를 선택하여 사이에 존재하는 점의 개수를 구하는 작업이 있다고 가정합시다. x의 범위는 int형의 범위인 -2^31 ~ 2^31-1 이고 중복은 없습니다. n은 5000 이하입니다. 입력은 n : 7, -2^31, -10000, 0 , -2000, 3, 6, 30000 , x1 = -10000, x2 = 30000 대략적으로 보면 그림과 같이 나타나게 됩니다. x1,x2 사이의 값을 구하게 되면 4개의 값이 나오게 됩니다. 이 경우 위의 값들을 아래와 같이 순위를 유지하면서 바꿔주어도 문제를 풀 수가있습니다. 이렇게   바꿔서 풀 수 있는 이유는 값보다 값의 순위가 중요하기 때문 입 니다. 압축좌표가  필요한 예 로, 카카오 코드 페스티벌 5번 캠핑 문제가 될 수 있습니다. 이 경우 좌표  x,y의 범위는 0 ~ 2^31-1  이지만, 입력받는  좌표의 개수는 최대 5000개  입니다. 만약 입력의 좌표를 그대로 반영하여 문제를 푼다고 하면 배열의 크기가 2^31-1 개가 되어야 합니다. 게다가 2차원으로.. 못풉니다. 탐색하다가 시간다 끝날꺼에요. 하지만 입력이 최대의 개수가 최대 5000이라고 했으니 좌표압축을 이용해 입력받은 좌표를 0~5000 으로 매치시키고 풀게되는 것 입니다.